## ros-lunar-avt-vimba-camera 0.0.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(avt_vimba_camera)

find_package(catkin REQUIRED COMPONENTS
  #libvimba
  camera_info_manager
  diagnostic_updater
  dynamic_reconfigure
  image_geometry
  image_transport
  message_filters
  roscpp
  sensor_msgs
  std_msgs
  polled_camera
)

#Get architecture
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(TargetArchitecture)
target_architecture(ARCH)

#add dynamic reconfigure api
generate_dynamic_reconfigure_options(
  cfg/AvtVimbaCamera.cfg
  cfg/AvtVimbaCameraStereo.cfg
)

catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS camera_info_manager diagnostic_updater dynamic_reconfigure image_geometry image_transport roscpp sensor_msgs std_msgs polled_camera
)

###########
## Build ##
###########

include_directories(
  #${libvimba_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
  include
)

function(add_dependencies_and_linkings arg)
  add_dependencies(${arg}
    ${PROJECT_NAME}_gencfg
    #${libvimba_EXPORTED_TARGETS}
  )

  if("${ARCH}" STREQUAL i386)
    target_link_libraries(${arg}
      ${catkin_LIBRARIES}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/32bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/32bit/libVimbaCPP.so
    )
  elseif("${ARCH}" STREQUAL x86_64)
    target_link_libraries(${arg}
      ${catkin_LIBRARIES}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaCPP.so
    )
  elseif("${ARCH}" STREQUAL armv7)
    target_link_libraries(${arg}
      ${catkin_LIBRARIES}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaCPP.so
    )
  else()
    message(FATAL_ERROR "[libvimba]: Architecture ${ARCH} not suported. Exiting...")
  endif()
endfunction(add_dependencies_and_linkings)

add_executable(mono_camera_node
  src/nodes/mono_camera_node.cpp
  src/mono_camera.cpp
  src/avt_vimba_camera.cpp
  src/frame_observer.cpp
)

add_dependencies_and_linkings(mono_camera_node)

add_executable(stereo_camera_node
  src/nodes/stereo_camera_node.cpp
  src/stereo_camera.cpp
  src/avt_vimba_camera.cpp
  src/frame_observer.cpp
)

add_dependencies_and_linkings(stereo_camera_node)

add_executable(sync_node
  src/nodes/sync_node.cpp
  src/sync.cpp
)

add_dependencies_and_linkings(sync_node)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS mono_camera_node stereo_camera_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
  launch/mono_camera.launch
  launch/stereo_camera_one_node.launch
  launch/stereo_camera_two_nodes.launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if("${ARCH}" STREQUAL i386)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/32bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/32bit/libVimbaCPP.so
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  )
elseif("${ARCH}" STREQUAL x86_64)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaCPP.so
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  )
elseif("${ARCH}" STREQUAL armv7)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaCPP.so
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  )
endif()

=== debian/changelog ===
ros-lunar-avt-vimba-camera (0.0.10-0stretch) stretch; urgency=high

  * Merge pull request #26 <https://github.com/srv/avt_vimba_camera/issues/26> from 130s/k/add_ci
    [CI] Add config for ROS Kinetic (and Lunar as an option).
  * [CI] Add config for ROS Kinetic (and Lunar as an option).
  * Merge pull request #25 <https://github.com/srv/avt_vimba_camera/issues/25> from mintar/fix_open_camera
    Fix opening the camera
  * Simplify openCamera() logic
  * Open camera on init
    Without this patch, the camera is never opened. This bug was introduced in 63f868791.
  * Give more information to the user
  * Merge pull request #22 <https://github.com/srv/avt_vimba_camera/issues/22> from plusone-robotics/dyn_reconfig_fix
    Dynamic reconfigure fix
  * Fix #21 <https://github.com/srv/avt_vimba_camera/issues/21>: Retry camera opening and handle SIGINT
  * Changed file mode in order to build
  * Fixed crashing of dynamic reconfigure
  * Fixed dynamic reconfigure configuration that did not allow camera parameters to be updated
  * Fix call QueueFrame() method
  * Fix CPU overhead issue
  * Fix #18 <https://github.com/srv/avt_vimba_camera/issues/18>
  * Merge pull request #17 <https://github.com/srv/avt_vimba_camera/issues/17> from josepqp/kinetic
    Added ARM 32 to CMakeList.txt
  * Stop camera before destroy it
  * Added ARM 32
  * Merge branch 'kinetic' of github.com:srv/avt_vimba_camera into kinetic
  * Change variable scope
  * Fix #15 <https://github.com/srv/avt_vimba_camera/issues/15>: do not depend on turbot_configurations
  * Merge pull request #14 <https://github.com/srv/avt_vimba_camera/issues/14> from josepqp/kinetic
  * Added ARM 32 bits libraries
    
    Modified CMakeList.txt to compile with ARM 32 bits
    
    Added Iris Parameter
  * kinetization
  * Fix sync problems after camera tests
  * Add a sync timer
  * Try stereo image sync
  * Add a check timer
  * Fix #12 <https://github.com/srv/avt_vimba_camera/issues/12>: allow bigger resolutions
  * Fix camera info
  * Fix camera config
  * Fix camera info when decimation
  * Make sync node acts as stereo sync checker
  * Include a check timer on stereo_camera
  * Perform the stereo_sync in a separate node
  * Publish camera temperatures
  * Change the way of reset
  * Increase the initial wait time before checking sync
  * Add a sync watcher node
  * Fix branch mix
  * Remove unused variables
  * Left and right callback in a separate thread
  * Change default sync time
  * change logging messages
  * fix binning
  * add stereo launchfiles
  * removed prints
  * set stereo launchfiles
  * removed unused params
  * calibration epi. 4
  * improvements to stereo node
  * merge with v2.0 SDK
  * upgrade to VIMBA SDK 2.0
  * upgrade to 1.4
  * changed ros prints from info to debug
  * removed comment
  * changed stereo camera launchfile
  * Merge pull request #11 <https://github.com/srv/avt_vimba_camera/issues/11> from lucasb-eyer/indigo
    Set the frame_id of the image header, too.
  * Set the frame_id of the image header, too.
  * Contributors: Isaac I.Y. Saito, Martin Günther, Miquel Massot, Shaun Edwards, SparusII, agoins, josep, lucasb-eyer, plnegre, shaun-edwards

 -- Miquel Massot <miquel.massot@uib.cat>  Tue, 15 Aug 2017 22:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.9-0stretch) stretch; urgency=high

  * Fix #8 <https://github.com/srv/avt_vimba_camera/issues/8>: Constructor delegation and typo in assignment
  * added mono camera name
  * corrected diagnostics
  * fixed sync diagnostic
  * improved diagnostics
  * better timestamp management
  * added command error check
  * cleaning stereo prints
  * removed old cpp
  * fixed merging conflict
  * update updater
  * added time to tick function
  * added getTimestamp
  * added reset timestamp command
  * changed errors to warnings
  * added open/close msgs to diagnostics
  * added diagnostics. wip
  * bugfixes
  * full operative stereo camera
  * prepared launchfile for stereo
  * auto set packet size
  * stereo sync
  * preparing for stereo
  * added launchfile
  * hide first run
  * set auto configuration by default
  * fix with ptp mode
  * Fix dynamic reconfigure error with PTP
  * mono camera compiles
  * Fix interface type
  * Merge pull request #5 <https://github.com/srv/avt_vimba_camera/issues/5> from lucasb-eyer/auto
    Fix names/values of auto settings.
  * Fix names/values of auto settings.
  * Fix #2 <https://github.com/srv/avt_vimba_camera/issues/2>: Set the highest GeV packet size
  * Merge pull request #3 <https://github.com/srv/avt_vimba_camera/issues/3> from pkok/single_identifier
    Allow user to connect by specifying either GUID or IP address.
  * Allow user to connect by specifying either GUID or IP address.
  * wip
  * added testing launchfiles
  * added parameters for sync
  * Contributors: Miquel Massot, Patrick de Kok, SPENCER-Freiburg Laptop

 -- Miquel Massot <miquel.massot@uib.cat>  Sun, 16 Nov 2014 23:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.8-0stretch) stretch; urgency=high

  * readdition of vimba
  * Contributors: Miquel Massot

 -- Miquel Massot <miquel.massot@uib.cat>  Thu, 04 Sep 2014 22:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.7-0stretch) stretch; urgency=high

  * removed vimba headers
  * Contributors: Miquel Massot

 -- Miquel Massot <miquel.massot@uib.cat>  Wed, 03 Sep 2014 22:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.6-0stretch) stretch; urgency=high

  * change to libvimba package
  * Contributors: Miquel Massot

 -- Miquel Massot <miquel.massot@uib.cat>  Tue, 02 Sep 2014 22:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.5-0stretch) stretch; urgency=high

  * add shared library as imported target
  * Contributors: Miquel Massot

 -- Miquel Massot <miquel.massot@uib.cat>  Tue, 02 Sep 2014 22:00:00 -0000

ros-lunar-avt-vimba-camera (0.0.4-0stretch) stretch; urgency=high

  * absolute path for libvimbacpp
  * changed version
  * bugfix re-release
  * Contributors: Miquel Massot



=== debian/control ===
Source: ros-lunar-avt-vimba-camera
Section: misc
Priority: extra
Maintainer: Miquel Massot <miquel.massot@uib.cat>
Build-Depends: debhelper (>= 9.0.0), ros-lunar-camera-info-manager, ros-lunar-catkin, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-image-geometry, ros-lunar-image-transport, ros-lunar-message-filters, ros-lunar-polled-camera, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-msgs
Homepage: http://wiki.ros.org/avt_vimba_ros
Standards-Version: 3.9.2

Package: ros-lunar-avt-vimba-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-camera-info-manager, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-image-geometry, ros-lunar-image-transport, ros-lunar-message-filters, ros-lunar-polled-camera, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-msgs
Description: Wrapper of the Allied Vision Technologies (AVT) VIMBA Ethernet and Firewire SDK.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-avt-vimba-camera//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
